<?php

/**
 * Login widget
 * based on the "Login with AJAX" plugin - http://netweblogic.com/wordpress/plugins/login-with-ajax
 *
 * @since 1.0
 * @todo add Register Form
 */
 
register_widget('atom_widget_login'); 
 
class atom_widget_login extends WP_Widget{

  function atom_widget_login(){
    $widget_ops = array('classname' => 'login', 'description' => _a("Login and Lost Password forms"));
    $control_ops = array('width' => 500);
    $this->WP_Widget('atom-login', _a("Login"), $widget_ops, $control_ops);

    add_action('init', array(&$this, 'ajax'), 99);

    // include in jQuery(document).ready()
    atom_add('jquery_init', array(&$this, 'js'));
  }

  function js(){
    // we need to process all instances because this function gets to run only once
    $widget_settings = atom_get_options($this->option_name);

    foreach((array)$widget_settings as $instance => $options):

      // identify instance
      $id = "{$this->id_base}-{$instance}";
      $block_id = "instance-{$id}";

      if (is_active_widget(false, $id, $this->id_base)): ?>

      $('#<?php echo $id; ?>_login').submit(function(event){

        // stop event
        event.preventDefault();

        $status = $("#<?php echo $block_id; ?> .status");
        $status.removeClass("error").addClass("loading").text("<?php _ae("Checking..."); ?>");

        // sort out url
        url = $('#<?php echo $id; ?>_login').attr('action');
        url += (url.match(/\?/) != null) ? '&callback=?' : '?callback=?' ;
        url += "&log="+encodeURIComponent($("#<?php echo $id; ?>_user").val());
        url += "&pwd="+encodeURIComponent($("#<?php echo $id; ?>_pass").val());
        url += "&rememberme="+encodeURIComponent($("#<?php echo $id; ?>_login_remember").val());
        url += "&login=login";

        $.getJSON(url, function(data, status){
          if(data.result === true || data.result === false){
            if(data.result === true){
              $status.removeClass("loading error").addClass("success").html(data.message);
              window.location.reload();
            }else{
              $status.removeClass("loading").addClass("error").html(data.error);

              // assume the link in the status message points to forgot pass form
              $status.find("a").click(function(event){
                event.preventDefault();

                if($("#<?php echo $id; ?>_forgot").is(":visible")){
                  var origColor = $("#<?php echo $id; ?>_forgot input.text").css("color");
                  $("#<?php echo $id; ?>_forgot input.text").css({backgroundColor: '#ffa799', color: '#333'}).animate({backgroundColor: '#fff', color: origColor}, 1000);
                }else{
                  $("#<?php echo $block_id; ?> a.forgot_pass").remove(); // remove the bottom forgot pass link
                  $('#<?php echo $id; ?>_forgot').slideFade('toggle',333,'easeOutQuart');
                }

              });
            }
          }else{
            $status.removeClass("loading").html("<?php _ae("Unkown error. Please try again..."); ?>");
          }
        });
      });

      $('#<?php echo $id; ?>_forgot').submit(function(event){

        // stop event
        event.preventDefault();

        $status = $("#<?php echo $block_id; ?> .status");
        $status.removeClass("error").addClass("loading").text("<?php _ae("Checking..."); ?>");

        // sort out url
        url = $('#<?php echo $id; ?>_forgot').attr('action');
        url += (url.match(/\?/) != null) ? '&callback=?' : '?callback=?' ;
        url += "&user_login="+$("#<?php echo $id; ?>_user_or_email").val();
        url += "&login=forgot_pass";

        $.getJSON(url, function(data, status){
          if(data.result === true || data.result === false){
            if(data.result == '1') $status.removeClass("loading error").addClass("success").html(data.message);
            else $status.removeClass("loading").addClass("error").html(data.error);
          }else{
            $status.removeClass("loading").addClass("error").html("<?php _ae("Unkown error. Please try again..."); ?>");
          }
        });
      });

      $("#<?php echo $block_id; ?> a.forgot_pass").click(function(event){
        event.preventDefault();
        $(this).remove();
        $('#<?php echo $id; ?>_forgot').slideFade('toggle',333,'easeOutQuart');
      });

      <?php endif;
    endforeach;
  }

  function ajax(){

    if(isset($_GET["login"])):
      atom_ajax_header();

      switch($_GET["login"]):
        case 'login':
          $_POST['log'] = $_GET['log'];
          $_POST['pwd'] = $_GET['pwd'];
          $_POST['rememberme'] = $_GET['rememberme'];

          global $current_user;
          $return = array(); //What we send back
          $loginResult = wp_signon();

          if(strtolower(get_class($loginResult)) == 'wp_user'):
            //User login successful
            $current_user = $loginResult;
            /* @var $loginResult WP_User */
            $return['result'] = true;
            $return['message'] = _a("Login Successful, redirecting...");

          elseif(strtolower(get_class($loginResult)) == 'wp_error'):
            //User login failed
            /* @var $loginResult WP_Error */
            $return['result'] = false;
            $error = $loginResult->get_error_message();
            $return['error'] = ($error ? $error : _a("Please type a username and password"));

          else:
            //Undefined Error
            $return['result'] = false;
            $return['error'] = _a('Unknown error. Sorry...');

          endif;
          $return = json_encode($return);
        break;

        case 'forgot_pass':
          $_POST['user_login'] = $_GET['user_login'];

          // Reads ajax login creds via POSt, calls the login script and interprets the result
          $remember = array(); //What we send back
          $result = retrieve_password();

          if($result === true):
            //Password correctly remembered
            $remember['result'] = true;
            $remember['message'] = _a("E-mail has been sent, check your inbox.");
          elseif(strtolower(get_class($result)) == 'wp_error'):
            //Something went wrong
            /* @var $result WP_Error */
            $remember['result'] = false;
            $remember['error'] = $result->get_error_message();
          else:
            //Undefined Error
            $remember['result'] = false;
            $remember['error'] = _a('Unknown error. Sorry...');
          endif;

          $return = json_encode($remember);
        break;

        default:
          $return = json_encode(array('result' => 0, 'error' => _a('Requested command is invalid')));
        break;
      endswitch;
      if(isset($_GET['callback'])) $return = $_GET['callback']."($return)";
      echo $return;
      exit();
    endif;
  }

  function widget($args, $instance){
    extract($args);
    $instance = wp_parse_args($instance, $this->defaults());
    $title = apply_filters('widget_title', $instance['title'], $instance, $this->id_base);

    // retrieve info about the current user
    global $current_user, $user_level;
    get_currentuserinfo();

    if(is_user_logged_in()) $title = sprintf(_a('Welcome %s'), $current_user->display_name);
    echo $before_widget.($title ? $before_title.$title.$after_title : null);

    echo '<div class="box login-block clear-block">';

    // the user is logged in, display the menu links
    if(is_user_logged_in()):
      echo '<div class="avatar">'.atom_get_avatar($current_user->user_email, 96, '', $current_user->display_name).'</div>';
      echo '<ul class="menu">';

      if($instance['dashboard']) echo '<li class="first"><a class="fadeThis" href="'.admin_url().'">'._a('Dashboard').'</a></li>';

      if($user_level >= 1): // need permissions
        if($instance['write'])  echo '<li><a class="fadeThis" href="'.admin_url('post-new.php').'">'._a('Write').'</a></li>';
        if($instance['comments']) echo '<li><a class="fadeThis" href="'.admin_url('edit-comments.php').'">'._a('Comments').'</a></li>';
      endif;

      if($instance['profile']) echo '<li><a class="fadeThis" href="'.admin_url('profile.php').'">'._a('Profile').'</a></li>';
      echo '<li><a class="fadeThis last" id="wp-logout" href="'.wp_logout_url(atom_get_current_page_url()).'">'._a('Log Out').'</a></li>';
      echo '</ul>';

    // the user is not logged in, display the login form
    else: ?>

      <div class="status clear-block"><?php echo $instance['text']; ?></div>

      <form id="<?php echo $this->id; ?>_login" action="<?php echo site_url('wp-login.php', 'login_post') ?>" method="post">

        <div>
          <input type="text" alt="<?php echo _a("User"); ?>" name="log" id="<?php echo $this->id; ?>_user" class="text clearField" value="" />
          <input type="password" alt="<?php echo _a("Password"); ?>" name="pwd" id="<?php echo $this->id; ?>_pass" class="text clearField" value="" />
        </div>

        <div class="clear-block">
          <input type="submit" name="wp-submit" class="alignleft" value="<?php _ae('Log In'); ?>" tabindex="100" />

          <input type="hidden" name="redirect_to" value="<?php echo atom_get_current_page_url(); ?>" />
          <input type="hidden" name="testcookie" value="1" />
          <input type="hidden" name="login" value="login" />

          <label for="<?php echo $this->id; ?>_login_remember" class="remember alignleft">
            <input name="rememberme" type="checkbox" id="<?php echo $this->id; ?>_login_remember" value="forever" />
            <?php _ae('Remember me'); ?>
          </label>
        </div>
      </form>

      <form id="<?php echo $this->id; ?>_forgot" action="<?php echo site_url('wp-login.php?action=lostpassword', 'login_post') ?>" method="post" class="hidden">
        <div>
          <input type="text" name="user_login" size="20" id="<?php echo $this->id; ?>_user_or_email" class="text wide clearField" value="<?php _ae("Enter username or email"); ?>" />
          <input type="submit" value="<?php echo _a("Get new password"); ?>" />
          <input type="hidden" name="login" value="forgot_pass" />
        </div>
      </form>

      <?php
      echo '<a class="forgot_pass" href="'.site_url('wp-login.php?action=lostpassword', 'login').'">'._a('Lost your password?').'</a>';

      if (atom_get_options('users_can_register')):
        if(function_exists('bp_get_signup_page')) $register_link = bp_get_signup_page(); // bp
        elseif(file_exists(ABSPATH."/wp-signup.php")) $register_link = site_url('wp-signup.php', 'login'); //MU + WP3
        else $register_link = site_url('wp-login.php?action=register', 'login');
        echo '<a class="register" href="'.$register_link.'">'._a('Register').'</a>';
      endif;

   endif;

   	echo '</div>';
	echo $after_widget;
  }

  function update($new_instance, $old_instance){
    $instance['title'] = esc_attr($new_instance['title']);
    if (current_user_can('unfiltered_html')) $instance['text'] =  $new_instance['text'];
    else $instance['text'] = stripslashes(wp_filter_post_kses(addslashes($new_instance['text']))); // wp_filter_post_kses() expects slashed
    $instance['dashboard'] = isset($new_instance['dashboard']);
    $instance['profile'] = isset($new_instance['profile']);
    $instance['write'] = isset($new_instance['write']);
    $instance['comments'] = isset($new_instance['comments']);
    return wp_parse_args($instance, $this->defaults());
  }

  function defaults(){
    // default settings
    return apply_filters('atom_widget_login_defaults', array(
      'title' => _a('Log in'),
      'text' => _a("Hello Guest. Login below if you have a account"),
      'dashboard' => 1,
      'profile' => 1,
      'write' => 1,
      'comments' => 0,
    ), $this);
  }

  function form($instance){
    $instance = wp_parse_args($instance, $this->defaults());
    ?>
    <div <?php atom_widget_form_class($this); ?>>
    <p>
      <label for="<?php echo $this->get_field_id('title'); ?>"><?php _ae('Title:'); ?>
      <input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php if (isset($instance['title'])) echo esc_attr($instance['title']); ?>" /></label>
    </p>

    <p>
      <label for="<?php echo $this->get_field_id('text'); ?>"><?php _ae('Initial Status Text (or HTML):'); ?>
      <textarea class="widefat code" id="<?php echo $this->get_field_id('text'); ?>" name="<?php echo $this->get_field_name('text'); ?>" rows="6" cols="28"><?php if (isset($instance['text'])) echo format_to_edit($instance['text']); ?></textarea>
      </label>
    </p>

    <p><strong><em><?php _ae("Welcome screen links (if enough permissions):"); ?></em></strong></p>
    <p>
     <label for="<?php echo $this->get_field_id('dashboard'); ?>">
       <input id="<?php echo $this->get_field_id('dashboard'); ?>" name="<?php echo $this->get_field_name('dashboard'); ?>" type="checkbox" value="1" <?php checked(isset($instance['dashboard']) ? $instance['dashboard'] : 0); ?> />
       <?php _ae('Dashboard'); ?>
     </label>
     <br />

     <label for="<?php echo $this->get_field_id('profile'); ?>">
       <input id="<?php echo $this->get_field_id('profile'); ?>" name="<?php echo $this->get_field_name('profile'); ?>" type="checkbox" value="1" <?php checked(isset($instance['profile']) ? $instance['profile'] : 0); ?> />
       <?php _ae('Profile'); ?>
     </label>
     <br />

     <label for="<?php echo $this->get_field_id('write'); ?>">
       <input id="<?php echo $this->get_field_id('write'); ?>" name="<?php echo $this->get_field_name('write'); ?>" type="checkbox" value="1" <?php checked(isset($instance['write']) ? $instance['write'] : 0); ?> />
       <?php _ae('Write'); ?>
     </label>
     <br />

     <label for="<?php echo $this->get_field_id('comments'); ?>">
       <input id="<?php echo $this->get_field_id('comments'); ?>" name="<?php echo $this->get_field_name('comments'); ?>" type="checkbox" value="1" <?php checked(isset($instance['comments']) ? $instance['comments'] : 0); ?> />
       <?php _ae('Comments'); ?>
     </label>
     <br />

     <label>
       <input disabled="disabled" type="checkbox" value="1" checked="checked" />
       <?php _ae('Log out'); ?>
     </label>
    </p>
    </div>
    <?php
  }
}