<?php
/**
 * jQuery initialization (ATOM framework)
 *
 * @package ATOM
 * @subpackage Template
 */

// get search query, if any
$referer = isset($_SERVER['HTTP_REFERER']) ? urldecode($_SERVER['HTTP_REFERER']) : false;
if(preg_match('@^http://(.*)?\.?(google|yahoo|lycos).*@i', $referer)):
  $search_query = $comment_filter_query = preg_replace('/^.*(&q|query|p)=([^&]+)&?.*$/i','$2', $referer);
else:
  $search_query = get_search_query();
  $comment_filter_query = atom_get_comment_filter_query();
endif;

// load separately as a javascript document (theme settings > advanced)?
if(atom_get_options('jquery_init_query')):
  header("content-type: application/x-javascript");
  header("Cache-Control: no-store, no-cache, must-revalidate");
  header("Pragma: no-cache");
endif;
?>
/*<![CDATA[*/

var AtomLocalize = new Array();

AtomLocalize['posting'] = "<?php _ae("Posting. Please wait..."); // comment post in progress ?>";
AtomLocalize['commentadded'] = "<?php _ae("Your comment was added."); // comment post complete ?>";
AtomLocalize['sendanother'] = "<?php _ae("Post another comment"); // another comment? ?>";
AtomLocalize['sending'] = "<?php _ae("Please wait..."); ?>";
AtomLocalize['tryagain'] = "<?php _ae("Try Again"); ?>";

var blog_url = '<?php echo home_url('/'); ?>';

// init
jQuery(document).ready(function($){

 <?php // sticky-footer (unfortunately the only way because of variable height) ?>
// $("#footer").css({
//   "position": "absolute",
//   "bottom": "0px",
//   "width": "100%"
// });
// $("#main").css({
//   "padding-bottom": $("#footer").height()+10,
//   "min-height": 0
// });

 $('.nav ul.menu').superfish();

 $('.accordion, .collapsible').AccordionMenu();

 <?php if(atom_get_options('lightbox')): // enable fancyBox for any link with rel="lightbox" and on links which references end in image extensions (jpg, gif, png) ?>
 $("a[rel*='lightbox'], a[href$='.jpg'], a[href$='.jpeg'], a[href$='.gif'], a[href$='.png'], a[href$='.JPG'], a[href$='.JPEG'], a[href$='.GIF'], a[href$='.PNG']").fancyboxlite({
    'zoomSpeedIn': 333,
    'zoomSpeedOut': 333,
    'zoomSpeedChange': 133,
    'transitionIn'	: 'elastic',
    'transitionOut'	: 'elastic',
    'easingIn'      : 'easeOutBack',
    'easingOut'     : 'easeInBack',
    'overlayShow': true,
    'overlayOpacity': 0.75
 });
 <?php endif; ?>

 <?php // search autocomplete ?>
 $('.suggestTerms').attr('autocomplete', 'off').autocomplete("<?php echo add_query_arg("atom", "list_terms", home_url('/')); ?>", {
     width: 260,
     max: 100,
     matchContains: true,
     minChars: 2,
     selectFirst: false,
     cache: true,
     formatItem: function(row, i, max) {
       return '<div class="clear-block"><span class="title">'+row[0]+'</span><span class="count">'+row[1]+'</span>';
     },
     multiple: false,
     //multipleSeparator: " "
 });

 <?php // read more - expand content ?>
 $('.post-content .more-link').click(function(event){
   event.preventDefault();

   $.ajax({
     url: blog_url,
     type: "GET",
     context: this,
     data: ({
       atom: 'read_more',
       post_id: $(this).attr('rel')
     }),
     beforeSend: function(){ },
     error: function(){ },
     success: function(data){
        $(this).closest('.post-content').html(data);
      }
   });
 });

 <?php // form input helpers ?>
 $('.clearField').clearField({
   blurClass: 'clearFieldBlurred',
   activeClass: 'clearFieldActive'
 });

 <?php // link screenshots ?>
  $('a.screenshot').each(function(i){
    $("body").append("<div class='webshot' id='webshot-"+i+"'><img src='http://s.wordpress.com/mshots/v1/"+escape($(this).attr('href'))+"?w=400' width='400' alt='<?php _ae("Preview");?>' /></div>");
    var tooltip = $("#webshot-"+i);
    $(this).mouseover(function () {
      tooltip.css({
        opacity: 1,
        display: "none"
      }).fadeIn(333);
    }).mousemove(function(kmouse) {
      tooltip.css({
        left: kmouse.pageX + 15,
        top: kmouse.pageY + 15
      });
    }).mouseout(function () {
      tooltip.fadeOut(333);
    });
  });


 <?php // remove default input values added by clearfield, if form is submitted with them. thanks Heeboo :) ?>
 $("form").submit(function(){
   $('.clearField', this).each(function(){
     if($(this).val() == ($(this).attr('alt') || 'http://')) $(this).val('');
   });
   return true;
 });

 <?php // tabs in comments ?>
 $('#meta .sections').cycle({
   fx: 'fade',
   before: function(curr, next, opts, fwd) {
     // little hack to get the slide content height
     var $ht = $(this).height()+20;

     // set the container's height to that of the current slide
     $(this).parent().animate({height: $ht}, 333, 'easeOutExpo');
   },
   speed: 500,
   pause: true,
   height: $($('#meta ul.tabs li.active').attr('href')).height(),
   containerResize: 0,
   easing: 'easeOutExpo',
   pager: '#meta ul.tabs',
   pagerAnchorBuilder: function(idx, slide) {
     // return selector string for existing anchor
     return '#meta ul.tabs li:eq(' + idx + ') a';
   },
   activePagerClass: 'active',
   timeout:  0
 });

 <?php // tabs in widgets ?>
 <?php // maybe I should add this section dynamically by hooking a tab_widget->js() function to init? ?>
 $('.widget-tabs').each(function(){
   var $id = $(this).attr('id');
   var $fx = '';
   var $ease = '';
   var $classes = $(this).attr('class').split(' ');

   // get the effects/ease options from classes
   for (var i = 0; i < $classes.length; i++){
     $matches = /^fx\-(.+)/.exec($classes[i]);
     if ($matches != null){
       if($fx != '') $fx = $fx + ', '+$matches[1];
       else $fx = $matches[1];
     }
     $matches = /^ease\-(.+)/.exec($classes[i]);
     if ($matches != null) $ease = $matches[1];
   }
   if($fx == '') $fx = 'fade';
   if($ease == '') $fx = 'swing';

   // get the active nav
   var $activeNav = '#'+$id+' ul.tabs li.active';

   // no active class found, widget might have changed. reset
   if($($activeNav).attr('class') == undefined){
     $activeNav = $('#'+$id+' ul.tabs li:first');
     $($activeNav).addClass('active');
     $('#'+$id+' '+$($activeNav).find('a').attr('href')).show();
   }
   var $index = $($activeNav).index();
   var $activeHeight = $($($activeNav).find('a').attr('href')).height();

   $('#'+$id+' .sections').cycle({
     fx: $fx,
     before: function(curr, next, opts, fwd) {
       // little hack to get the slide content height
       // we need to make the slide temporarily visible to retrieve it's children height
       $styles = $(this).attr('style');
       $(this).show();
       var $ht = $(this).find('.block-content').height();
       $(this).attr('style', $styles);
       //set the container's height to that of the current slide
       $(this).parent().animate({height: $ht +5}, 333, $ease);
     },
     after:function(curr, next, opts, fwd) {
       // set the cookie (php will add or not the active/hidden classes based on this)
       $cookieValue = $($activeNav).attr("id");
       $.cookie($id , $cookieValue, { path: '/' });
     },
     speed: (($fx != 'toss') ? 500 : 2000),
     pause: true,
     height: $activeHeight,
     containerResize: 0,
     startingSlide: $index,
     easing: $ease,
     pager: '#'+$id+' ul.tabs',
     pagerAnchorBuilder: function(idx, slide) {
       // return selector string for existing anchor
       return '#'+$id+' ul.tabs li:eq(' + idx + ') a';
     },
     activePagerClass: 'active',
     timeout:  0
   });
 });

 <?php // set accessibility roles on some elements trough js (to not break the xhtml markup) ?>
 $(".nav").attr("role", "navigation");
 $("#primary-content").attr("role", "main");
 $("#sidebar, #sidebar2").attr("role", "complementary");
 $(".search-form").attr("role", "search");

 <?php if(atom_get_options('comment_karma')): // karma ajax ?>
 $("#comments").delegate("a.vote", "click", function(event){
   event.preventDefault();

   $.ajax({
     url: blog_url,
     type: "GET",
     context: this,
     data: ({
       atom: 'comment_karma',
       karma: $(this).attr('rel')
     }),
     beforeSend: function(){ },
     error: function(){ },
     success: function(data){
        var status = $(this).parent().find('.karma');
        status.html(data);
        if(parseInt(data) > 0){
          status.removeClass("negative");
          status.addClass("positive");
        }
        else if(parseInt(data) < 0){
          status.removeClass("positive");
          status.addClass("negative");
        }
        $(this).parent().find('a').remove();
      }
   });
 });

 <?php // update comment karma ?>
 $("#comments").delegate("a.show", "click", function(event){
   event.preventDefault();

   $.ajax({
     url: blog_url,
     type: "GET",
     context: this,
     data: ({
       atom: 'get_comment',
       comment_id: $(this).attr('rel')
     }),
     beforeSend: function(){ },
     error: function(){ },
     success: function(data){
       var comment = $('<ul />').html(data);
       var commentbody = comment.find(".comment-body").hide();
       var commentbodyOuterHTML = commentbody[0].outerHTML || commentbody.clone().appendTo('<div>').parent().html();

       $(this).parents('.comment-head').after(commentbodyOuterHTML);

       $(this).parents('li').find('.comment-body').animate({
                    "opacity": "show",
                    "height": "show",
                    "marginTop": "show",
                    "marginBottom": "show",
                    "paddingTop": "show",
                    "paddingBottom": "show"
                  }, 333);

       $(this).remove();
      }
   });
 });
 <?php endif; ?>

 <?php // quote comment ?>
 $("#comments").delegate("a.quote", "click", function(event){
   event.preventDefault();
   $('#comment').appendVal(
       '<blockquote>\n<a href="'
     + $('.comment-id', $(this).parents('li div.comment')).attr('href') + '">\n<strong><em>'
     + $('.comment-author', $(this).parents('li div.comment')).html()
     + ':</em></strong>\n</a>\n '
     + $('.comment-content', $(this).parents('li div.comment')).html() + '</blockquote>');

   $('#comment').focus();
 })

 <?php // replaces wp's comment reply script ?>
 $("#comments").delegate("a.reply", "click", function(event){
   event.preventDefault();

   linkClass = $(this).attr('id');
   var pos = linkClass.lastIndexOf('-');
   var targetID = linkClass.substr(++pos);

   $(".comment.new").hide();
   $('#comment_parent').attr('value', targetID);

   $("#cancel-reply").show();
   $(".comment.new").appendTo('#comment-body-'+targetID).show(0, function(){
     // move cursor in textarea, at the end of the text
     $('#comment').each(function(){
       if (this.createTextRange) {
        var r = this.createTextRange();
        r.collapse(false);
        r.select();
       }
       $(this).focus();
     });

   });
 });

 <?php // cancel reply ?>
 $("#comments").delegate("#cancel-reply", "click", function(event){
   event.preventDefault();

   $(".comment.new").hide();
   $('#comment_parent').attr('value','0');

   $("#cancel-reply").hide();
   $(".comment.new").appendTo('li.new').show(0,function(){
     // move cursor in textarea, at the end of the text
     $('#comment').each(function(){
       if (this.createTextRange) {
        var r = this.createTextRange();
        r.collapse(false);
        r.select();
       }
       $(this).focus();
     });

    });
  });

 <?php // toggle content ?>
 $(".toggle").live("click", function(){
   event.preventDefault();

   var target = $("."+$(this).attr('rel'), this.parent);
   $(target).slideFade('toggle', 333, 'easeOutQuart');
 });

 <?php if(!empty($search_query)): ?>
 $(".hentry").each(function(){ $(this).highlight('<?php echo $search_query; ?>', 1, "highlight"); });
 <?php endif; ?>

 <?php if(!empty($comment_filter_query)): ?>
 $("#comments .comment-text").each(function(){ $(this).highlight('<?php echo $comment_filter_query; ?>', 1, "highlight"); });
 <?php endif; ?>

 <?php // fade effect, might be cpu intensive because it's live (needs more testing) ?>
 $('ul.menu li a').addClass("fadeThis");
 if($.support.opacity && window.XMLHttpRequest)
   $('a.fadeThis').livequery(function(){
     $(this).append('<span class="hover"></span>').each(function(){
       var span = $('> span.hover', this).css('opacity', 0);
       $(this).hover(function() { span.stop().fadeTo(200, 1); },
                     function() { span.stop().fadeTo(800, 0); });
     });
   });




 <?php // search form submit with link ?>
 $(".search-form").each(function(){
    form = $(this);
    $('a.submit', this).click(function(){
      form.submit();
    });
 });

 <?php // tooltips that follow the mouse ?>
 $('a.tt').bubble();

 <?php // used on social media links ?>
 $('ul[class*="nudge-"] a').each(function(){
   var classes = $(this).closest('ul').attr('class');
   var amount = parseInt(/amount-(\d+)/.exec(classes)[1], 10);
   var direction = /nudge-([^\s]+)/.exec(classes)[1];
   $(this).nudge({
     property: 'margin' + direction.charAt(0).toUpperCase() + direction.slice(1),
     amount: -(amount),
     duration: 166
   });
 });

 <?php if(atom_get_options('generate_thumbs')): // auto resize thumbs ?>
 $('span.no-img.regen').livequery(function(){
    var id = $(this).attr('id').split(/-/g).slice(1);
    $(this).removeClass("regen");
    $.ajax({
      url: blog_url,
      type: "GET",
      context: this,
      data: ({
        atom: 'update_thumb',
        attachment_size: $(this).attr('rel'),
        post_id: id[0],
        thumb_id: id[1]
        }),
      beforeSend: function() { $(this).addClass('loading'); },
      success: function(data) {
        if(data != '') $(this).replaceWith(data); else $(this).removeClass('loading');
      }
	});
 });
 <?php endif; ?>

 <?php // scroll to top link ?>
 $('a.go-top').each(function(){
   var link = $(this);

   // link click event
   link.click(function () { $('html').animate({ scrollTop: 0 }, 'slow'); return true; });

   // window scroll event
   $(window).scroll(function(){
     //stupid IE hack
     if(!$.support.hrefNormalized){
       link.css({'position': 'absolute', 'top': $(window).scrollTop() + $(window).height() - 50});
     }
     if($(window).scrollTop() >= 500) link.fadeIn(200); else link.fadeOut(200);
   });
 });

 <?php if(atom_preview_mode()): // communication between the theme options page and the preview document ?>
 $('body').addGrid(12, {img_path: '<?php echo THEME_URL; ?>/core/admin/i/'});

 <?php if(atom_is_option_enabled('background_color')): ?>
 pm.bind("background-color", function(data){
   if(data != '#000000')
     $("<?php echo atom_get_options('background_color_selector'); ?>").css("background-color", data);
   else
     $("<?php echo atom_get_options('background_color_selector'); ?>").css("background-color", "");
 });
 <?php endif; ?>

 <?php if(atom_is_option_enabled('color_scheme')): ?>
 pm.bind("color-scheme", function(data){
   $('link#<?php echo ATOM; ?>-core-css, link#<?php echo ATOM; ?>-style-css').attr('disabled', 'disabled'); // we need this so the style unloads from browser memory
   $('link#<?php echo ATOM; ?>-core-css, link#<?php echo ATOM; ?>-style-css').remove();
   if(data != '')
     $('head').append('<link rel="stylesheet" id="<?php echo ATOM; ?>-core-css" href="<?php echo THEME_URL; ?>/style.css" type="text/css" />');
     $('head').append('<link rel="stylesheet" id="<?php echo ATOM; ?>-style-css" href="<?php echo THEME_STYLES_URL; ?>/'+data+'" type="text/css" />');
 });
 <?php endif; ?>

 <?php if(atom_is_option_enabled('layout')): ?>

 pm.bind("layout", function(data) {
   $('body').attr('class',
          function(i, c){
            return c.replace(/\bcol-\S+/g, '');
          });
   $("body").addClass(data);
 });

 pm.bind("page_width", function(data){
   $('body').removeClass("fluid fixed");
   $("body").addClass(data);
  });

 pm.bind("page_width_max", function(data){
   data = parseInt(data);
   if(data > 400) $(".page-content").css("max-width", data+'px');
 });

 pm.bind("dimensions", function(data){
   var s = data.sizes.split(';');
   s[0] = parseInt(s[0]);
   s[1] = parseInt(s[1]);
   var unit = data.unit;
   var gs = data.gs;
   switch(data['layout']){
      case 'col-1':
        $('#primary-content').css({'width': gs+unit, 'left': '0'});
        $('#mask-1').css({'right': 0});
        $('#mask-2').css({'right': 0});
        break;
      case 'col-2-left':
        $('#primary-content').css({'width': gs-s[0]+unit, 'left': gs+unit});
        $('#sidebar').css({'width': s[0]+unit, 'left': '0'});
        $('#mask-1').css({'right': gs-s[0]+unit});
        $('#mask-2').css({'right': 0});
        break;
      case 'col-2-right':
        $('#primary-content').css({'width': gs-(gs-s[0])+unit, 'left': gs-s[0]+unit});
        $('#sidebar').css({'width': gs-s[0]+unit, 'left': gs-s[0]+unit});
        $('#mask-1').css({'right': gs-s[0]+unit});
        $('#mask-2').css({'right': 0});
        break;
      case 'col-3':
        $('#primary-content').css({'width': (gs-s[0]-(gs-s[1]))+unit, 'left': gs+unit});
        $('#sidebar').css({'width': s[0]+unit, 'left': gs-s[1]+unit});
        $('#sidebar2').css({'width': gs-s[1]+unit, 'left': (gs-s[0])+unit});
        $('#mask-2').css({'right': gs-s[1]+unit});
        $('#mask-1').css({'right': ((gs-s[0])-(gs-s[1]))+unit});
        break;
      case 'col-3-left':
        $('#primary-content').css({'width': (gs-s[1])+unit, 'left': (gs+(s[1]-s[0]))+unit});
        $('#sidebar').css({'width': s[0]+unit, 'left': (s[1]-s[0])+unit});
        $('#sidebar2').css({'width': (s[1]-s[0])+unit, 'left': (s[1]-s[0])+unit});
        $('#mask-2').css({'right': (gs-s[1])+unit});
        $('#mask-1').css({'right': (s[1]-s[0])+unit});
        break;
      case 'col-3-right':
        $('#primary-content').css({'width': s[0]+unit, 'left': ((gs-s[0]-(gs-s[1]))+(gs-s[1]))+unit});
        $('#sidebar').css({'width': (gs-s[0]-(gs-s[1]))+unit, 'left': (gs-s[0])+unit});
        $('#sidebar2').css({'width': (gs-s[1])+unit, 'left': (gs-s[0])+unit});
        $('#mask-2').css({'right': (gs-s[1])+unit});
        $('#mask-1').css({'right': (s[1]-s[0])+unit});
        break;
    }
 });

 <?php endif; ?>

 <?php if(atom_is_option_enabled('logo')): ?>
 pm.bind("logo", function(data) {
   $("#logo a img").remove();
   if (data != 'remove')
     $("#logo a").html('<img src="'+data+'" />');
   else $("#logo a").html('<?php echo apply_filters('atom_logo_title', get_bloginfo('name')); ?>');
 });
 <?php endif; ?>

 <?php if(atom_is_option_enabled('background_image')): ?>
 pm.bind("background_image", function(data){
   if (data != 'remove')
    $("<?php echo atom_get_options('background_image_selector'); ?>").css('background-image', 'url("'+data+'")');
   else $("<?php echo atom_get_options('background_image_selector'); ?>").css('background-image', 'none');
 });
 <?php endif; ?>

 <?php endif; ?>

 <?php atom("jquery_init"); // extra code may be added by widgets, plugins etc. ?>
});

/* ]]> */