<?php /* ATOM/digitalnature */

   // This template styles the meta sections on singular type pages: comments, pings, related posts and author bio.
   // The template replaces the comments.php file found in generic themes. This is because we handle more than just comments here.
   // For custom post types, a meta-post_type.php template overrides this one.

  ?>
        
<?php
 // load comments
 $comments = atom_get_comments();

 // don't show this section if we're on a page with comments disabled and without any comments or pings in it
 // (we're assuming the site admin doesn't want this section on such pages)
 if (post_password_required() || (!comments_open() && is_page() && empty($comments))) return;


 // related posts
 $related_posts = (atom_get_options('single_related') ? atom_get_related_posts() : false);

 // author bio
 $author_bio = (atom_get_options('single_author') ? atom_get_author_info() : false);

 ?>
 <div id="meta">
   <ul class="tabs clear-block">
     <li class="active">
       <a href="#comments">
         <?php
          if(atom_get_comment_filter_query())
            printf(_a('Searching for %1$s (%2$s)'), '<em>'.atom_get_comment_filter_query().'</em>', atom_comment_count());
          else
            printf(_a('Comments (%s)'), atom_comment_count());
         ?>
       </a>
     </li>
     <?php if(atom_ping_count() > 0): ?><li><a href="#pings"><?php printf(_a("Pings (%s)"), atom_ping_count()); ?></a></li><?php endif; ?>
     <?php if($related_posts): ?><li><a href="#related-posts"><?php _ae("Related Posts"); ?></a></li><?php endif; ?>
     <?php if($author_bio): ?><li><a href="#about-the-author"><?php _ae("About the Author"); ?></a></li><?php endif; ?>
   </ul>

   <div class="sections clear-block">

     <ol class="section <?php if(atom_ping_count() > 0 || $related_posts || $author_bio) echo "hidden"; ?>" id="comments">
       <?php if(atom_get_options('comment_order') == 'desc'): ?>
       <li class="new">
         <?php atom_comment_form(); ?>
       </li>
       <?php endif; ?>

       <?php atom_comments($comments); ?>

       <?php if(atom_get_options('comment_order') != 'desc'): ?>
       <li class="new">
         <?php atom_comment_form(); ?>
       </li>
       <?php endif; ?>

       <li class="clear-block">

          <?php if(atom_comment_count() > 10 && atom_get_options('comment_filter')): // show filter only if it's enabled and if we have more than 10 comments ?>
          <div class="clear-block">
            <?php atom_comment_filter_form("alignright"); ?>
          </div>
          <?php endif; ?>

          <div class="clear-block">
           <?php atom_comment_navi("alignleft"); ?>
           <a class="rss-block alignright" rel="rss" href="<?php echo get_post_comments_feed_link(); ?>"><?php _ae("Comment Feed for this Post"); ?></a>
          </div>
       </li>
     </ol>

     <?php if(atom_ping_count() > 0): ?>
     <ol class="section hidden" id="pings">
       <?php atom_pings($comments); ?>
     </ol>
     <?php endif; ?>

     <?php if($related_posts): ?>
     <ol class="section hidden" id="related-posts">
       <?php echo $related_posts; ?>
     </ol>
     <?php endif; ?>

     <?php if($author_bio): ?>
     <ol class="section hidden" id="about-the-author">
       <li class="clear-block">
       <?php echo $author_bio; ?>
       </li>
     </ol>
     <?php endif; ?>

   </div>
 </div>