<?php /* ATOM/digitalnature */

 //  Singular template, usually used to display a single post.
 //  For custom post types, a template named single-post_type.php will have priority over this one.

 get_header();
?>

  <!-- main content: primary + sidebar(s) -->
  <div id="mask-3" class="clear-block">
   <div id="mask-2">
    <div id="mask-1">

      <!-- primary content -->
      <div id="primary-content">
       <div class="blocks clear-block">

        <?php atom("before_primary"); ?>

        <?php if(have_posts()): ?>
          <div class="posts clear-block">
          <?php while(have_posts()): ?>
            <?php the_post(); ?>

            <?php if(atom_get_options('single_links')): ?>
            <div class="post-links clear-block">
              <div class="alignleft"><?php previous_post_link('&laquo; %link') ?></div>
              <div class="alignright"><?php next_post_link('%link &raquo;') ?></div>
            </div>
            <?php endif; ?>

            <?php atom("before_post"); ?>

            <!-- post -->
            <div id="post-<?php the_ID(); ?>" <?php post_class('primary'); ?>>

              <?php if(!get_post_meta($post->ID, 'hide_title', true)): ?>
              <h1 class="title"><?php the_title(); ?></h1>
              <?php endif; ?>

              <div class="post-content clear-block">
               <?php the_content(); ?>
              </div>

              <?php atom_link_pages(); ?>

              <?php if($tags = atom_get_post_terms()): ?>
              <div class="post-extra clear-block">
                <div class="post-tags">
                  <?php echo implode(' ', $tags); ?>
                </div>
              </div>
              <?php endif; ?>


              <?php if(!post_password_required()): ?>

              <div class="post-meta">

                  <?php atom_share_this(); ?>

                  <?php if(atom_get_options("single_meta")): ?>
                  <div class="details">
                    <p>
                    <?php
                    printf(_a('This entry was posted by %1$s on %2$s at %3$s, and is filed under %4$s. Follow any responses to this post through %5$s.'), '<a href="'. get_author_posts_url(get_the_author_meta('ID')) .'" title="'. sprintf(_a("Posts by %s"), esc_attr(get_the_author())).' ">'. get_the_author() .'</a>', get_the_time(atom_get_options('date_format')),get_the_time(atom_get_options('time_format')), get_the_category_list(', '), '<a href="'.get_post_comments_feed_link($post->ID).'" title="RSS 2.0">RSS 2.0</a>');echo ' ';

                    if (('open' == $post->comment_status) && ('open' == $post->ping_status)): // Both Comments and Pings are open
                      printf(_a('You can <a%1$s>leave a response</a> or <a%2$s>trackback</a> from your own site.'), ' href="#commentform"',' href="'.get_trackback_url().'" rel="trackback"');
                    elseif (!('open' == $post->comment_status) && ('open' == $post->ping_status)): // Only Pings are Open
                      printf(_a('Responses are currently closed, but you can <a%1$s>trackback</a> from your own site.'), ' href="'.get_trackback_url().'" rel="trackback"');
                    elseif (('open' == $post->comment_status) && !('open' == $post->ping_status)): // Comments are open, Pings are not
                      _ae('You can skip to the end and leave a response. Pinging is currently not allowed.');
                    elseif (!('open' == $post->comment_status) && !('open' == $post->ping_status)): // Neither Comments, nor Pings are open
                      _ae('Both comments and pings are currently closed.');
                    endif;
                    ?>
                    </p>
                  </div>
                  <?php endif; ?>

              </div>
              <?php endif; ?>

              <div class="post-controls">
                <?php edit_post_link(_a('Edit')); ?>
                <?php atom_print_link(_a('Print')); ?>
              </div>

            </div>
            <!-- /post -->
            <?php atom("after_post"); ?>

          <?php endwhile; ?>
          </div>

          <?php atom_meta(); ?>

        <?php else: ?>
          <h1 class="title error"><?php _ae("Oops, nothing here :("); ?></h1>
        <?php endif; ?>

        <?php atom("after_primary"); ?>

       </div>
      </div>
      <!-- /primary content -->

      <?php get_sidebar(); ?>

    </div>
   </div>
  </div>
  <!-- /main content -->

<?php get_footer(); ?>
