<?php /* ATOM/digitalnature */

   // This is the template that styles post teasers on homepage and archive pages (or all pages except those of "singular" type).
   // If there are custom post types and there's a template named teaser-post_type.php it will be used instead of this one.

   // top info bar
   $primary = (atom_get_options('post_date') || atom_get_options('post_category') || atom_get_options('post_author')) && (!atom_is_sticky());

   // bottom tags & comment links
   $secondary = ((atom_get_options('post_tags') && $tags = atom_get_post_terms()) || atom_get_options('post_comments'));
  ?>

  <!-- post -->
  <div id="post-<?php the_ID(); ?>" <?php post_class(); ?>>

    <?php atom_post_thumb(); ?>

    <?php if(!atom_thumbnails_only() || atom_is_sticky()): ?>
    <div class="post-details">

      <?php atom_post_title('h2'); ?>

      <?php if($primary): ?>
      <div class="post-info">

        <?php if(atom_get_options('post_date') || atom_is_sticky()): ?>
          <span class="d"><?php echo atom_get_post_date(atom_get_options('post_date_mode')); ?></span>
        <?php endif; ?>

        <?php if(atom_get_options('post_author') || atom_is_sticky()): ?>
          <span class="a"><?php printf(_a('Posted by %s'), atom_get_post_author()); ?> </span>
        <?php endif; ?>

        <?php if((atom_get_options('post_category') && $categories = implode(', ', atom_get_post_terms(NULL, 'category'))) || atom_is_sticky()): ?>
          <span class="a"><?php printf(_a('Filed under %s'), $categories); ?></span>
        <?php endif; ?>

      </div>
      <?php endif; ?>

      <div class="post-content clear-block"> <?php atom_post_content(); ?> </div>

      <?php if($secondary): ?>
      <div class="post-extra">

        <?php if (atom_get_options('post_comments') || atom_is_sticky()): ?>
        <?php if(comments_open()): ?>
        <a class="comments" href="<?php the_permalink(); ?>#comments"><?php printf(_a("Comments (%s)"), $post->comment_count); ?></a>
        <?php else: ?>
        <span class="comments"><?php _ae("Comments are closed"); ?></span>
        <?php endif; ?>
        <?php endif; ?>

        <?php if(atom_get_options('post_tags') && $tags): ?>
        <div class="post-tags"> <?php echo implode(' ', $tags); ?> </div>
        <?php endif; ?>

      </div>
      <?php endif; ?>

    </div>
    <?php endif; ?>

    <div class="post-controls"> <?php edit_post_link(_a('Edit')); ?> </div>
  </div>
  <!-- /post -->
